package com.me.asteroids.systems;

import com.me.asteroids.components.DecayComponent;
import com.me.common.ecs.ComponentMapper;
import com.me.common.ecs.Engine;
import com.me.common.ecs.Entity;
import com.me.common.ecs.EntitySystem;

public class DecaySystem extends EntitySystem {

    private ComponentMapper<DecayComponent> decayTimerMapper;

    public DecaySystem(Engine engine) {
        super(engine, DecayComponent.class);
        decayTimerMapper = engine.getComponentMapper(DecayComponent.class);
    }

    @Override
    public void processEntity(Entity entity, float dt) {
        DecayComponent decayComponent = decayTimerMapper.get(entity);
        if ((decayComponent.decayTimer -= dt) <= 0) {
            if (decayComponent.remove) {
                entity.remove();
            } else {
                entity.deactivate();
            }

        }
    }

}
